// Copyright 2020-2021 the Pinniped contributors. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"time"

	v1alpha1 "go.pinniped.dev/generated/1.17/apis/supervisor/config/v1alpha1"
	scheme "go.pinniped.dev/generated/1.17/client/supervisor/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// FederationDomainsGetter has a method to return a FederationDomainInterface.
// A group's client should implement this interface.
type FederationDomainsGetter interface {
	FederationDomains(namespace string) FederationDomainInterface
}

// FederationDomainInterface has methods to work with FederationDomain resources.
type FederationDomainInterface interface {
	Create(*v1alpha1.FederationDomain) (*v1alpha1.FederationDomain, error)
	Update(*v1alpha1.FederationDomain) (*v1alpha1.FederationDomain, error)
	UpdateStatus(*v1alpha1.FederationDomain) (*v1alpha1.FederationDomain, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.FederationDomain, error)
	List(opts v1.ListOptions) (*v1alpha1.FederationDomainList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.FederationDomain, err error)
	FederationDomainExpansion
}

// federationDomains implements FederationDomainInterface
type federationDomains struct {
	client rest.Interface
	ns     string
}

// newFederationDomains returns a FederationDomains
func newFederationDomains(c *ConfigV1alpha1Client, namespace string) *federationDomains {
	return &federationDomains{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the federationDomain, and returns the corresponding federationDomain object, and an error if there is any.
func (c *federationDomains) Get(name string, options v1.GetOptions) (result *v1alpha1.FederationDomain, err error) {
	result = &v1alpha1.FederationDomain{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("federationdomains").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of FederationDomains that match those selectors.
func (c *federationDomains) List(opts v1.ListOptions) (result *v1alpha1.FederationDomainList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.FederationDomainList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("federationdomains").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested federationDomains.
func (c *federationDomains) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("federationdomains").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a federationDomain and creates it.  Returns the server's representation of the federationDomain, and an error, if there is any.
func (c *federationDomains) Create(federationDomain *v1alpha1.FederationDomain) (result *v1alpha1.FederationDomain, err error) {
	result = &v1alpha1.FederationDomain{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("federationdomains").
		Body(federationDomain).
		Do().
		Into(result)
	return
}

// Update takes the representation of a federationDomain and updates it. Returns the server's representation of the federationDomain, and an error, if there is any.
func (c *federationDomains) Update(federationDomain *v1alpha1.FederationDomain) (result *v1alpha1.FederationDomain, err error) {
	result = &v1alpha1.FederationDomain{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("federationdomains").
		Name(federationDomain.Name).
		Body(federationDomain).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *federationDomains) UpdateStatus(federationDomain *v1alpha1.FederationDomain) (result *v1alpha1.FederationDomain, err error) {
	result = &v1alpha1.FederationDomain{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("federationdomains").
		Name(federationDomain.Name).
		SubResource("status").
		Body(federationDomain).
		Do().
		Into(result)
	return
}

// Delete takes name of the federationDomain and deletes it. Returns an error if one occurs.
func (c *federationDomains) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("federationdomains").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *federationDomains) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("federationdomains").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched federationDomain.
func (c *federationDomains) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.FederationDomain, err error) {
	result = &v1alpha1.FederationDomain{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("federationdomains").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
